<?php
namespace Geral\Entities;

/**
 * Class Estruturam
 * @package Geral\Entities
 * @method static \Geral\Entities\Estruturam findOneByNrestruturamAndNrorg($nrestruturam, $nrorg)
 * @method static \Geral\Entities\Estruturam findOneByCdintestruturaAndNrorg($cdfilial, $nrorg)
 */
class Estruturam extends Base\Estruturam
{

    public function __construct(){
        $this->dtinclusao = new \DateTime();
        $this->idativo = 'S';
    }

    // LISTA DE MÉTODOS UTILIZADOS EXCLUISIVAMENTE NA MIGRACAO ALINUTRI.
    public static function getEstruturaPorCdintestrutura($cdestrutura, $nrorg) 
    {
        $estruturam   = \Geral\Repositories\Estruturam::getEstrutura($cdestrutura, $nrorg);
        $nrestruturam = $estruturam["NRESTRUTURAM"];
        if (!$nrestruturam) {
            $nrestruturam = \Geral\Util\NovoCodigo::geraNovoCodigoMigracao('ESTRUTURAM', 'NRESTRUTURAM', $nrorg);
        }

        return $nrestruturam;
    }

    /**
     * Gera um parceiro de negocios uma estruturam e uma estruturah para cada filial que não os possua.
     */
    public  static function geraEstruturaFilial(){
        $tipo_parceiro="Insert into TIPOPARCEIRO (CDTIPOPARCEIRO,NMTIPOPARCEIRO,NRORG,IDATIVO,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU) values ('ESTRUTURA','ESTRUTURA','1','S',null,null,'1','1','1','1')";
        try{
            $db = \Setforms2\Runtime\Connection::getInstance();
            $db->execute($tipo_parceiro);
        }catch(\Exception $e){
            //se der erro ignora
        }

        $sql = "DECLARE
            V_PRXCODIGO_M           VARCHAR2(20);
            V_PRXCODIGO_H           VARCHAR2(20);
            V_PRXCODIGO_PARCNEGOCIO VARCHAR2(20);
            V_CDSITUCRT             VARCHAR2(01);
            V_DTREFERENCIA          DATE;
            V_COUNT 		            NUMBER;
            V_TIPOINSC 	            VARCHAR2(10);
            V_TIPOPARC 	            VARCHAR2(12);
            BEGIN
               V_DTREFERENCIA := TO_DATE('01/01/2000', 'DD/MM/YYYY');
               FOR C_FILIAL IN
               (SELECT CDFILIAL,
                          NMFILIAL,
                          NRORG,
                          CDEMPRESA,
                          REPLACE(REPLACE(REPLACE(REPLACE(NRINSJURFILI, '.',''),'/',''),'-',''),' ','') NRINSJURFILI
                     FROM FILIAL
                    WHERE NOT EXISTS (SELECT 1
                                        FROM ESTRUTURAM
                                       WHERE CDINTESTRUTURA = FILIAL.CDFILIAL
                    AND NRTIPOESTRUTURA = 2))
               LOOP
                  /*VERIFICA SE A EMPRESA É DO SIMPLES NACIONAL, '3' NAO É DO SIMPLES, APENAS 1 E 2*/
                  SELECT NVL(MAX(CDSITUCRT), '3') CDSITUCRT
                    INTO V_CDSITUCRT
                    FROM PARAMEMPRESA
                   WHERE CDEMPRESA = C_FILIAL.CDEMPRESA;

                  NOVO_CODIGO('ESTRUTURAM', V_PRXCODIGO_M);
                  NOVO_CODIGO('ESTRUTURAH', V_PRXCODIGO_H);
                  NOVO_CODIGO('PARCNEGOCIO', V_PRXCODIGO_PARCNEGOCIO);

                  INSERT INTO PARCNEGOCIO(NRPARCNEGOCIO, NRORG, NMPRINCIPALPARC, NMSECUNDARIPARC, NRINSCRICAOPARC,
                        IDATIVO, DTINCLUSAO, CDTIPOINSCRICAO, IDPESSOAFISICA, IDINSTITUICAO,
                        CDTIPOPARCPRINCIPAL)
                  VALUES(TO_NUMBER(V_PRXCODIGO_PARCNEGOCIO), C_FILIAL.NRORG, C_FILIAL.NMFILIAL, C_FILIAL.NMFILIAL, NVL(C_FILIAL.NRINSJURFILI, C_FILIAL.CDFILIAL),
                      'S', SYSDATE, 'CNPJ', 'N', 'S', 'ESTRUTURA');

                  INSERT INTO ESTRUTURAM(NRESTRUTURAM, CDINTESTRUTURA, NRORG, NRTIPOESTRUTURA, DTINIVIGENCIA, DTINCLUSAO)
                  VALUES(TO_NUMBER(V_PRXCODIGO_M), C_FILIAL.CDFILIAL, C_FILIAL.NRORG, 2, V_DTREFERENCIA, SYSDATE);

                  INSERT INTO ESTRUTURAH(NRESTRUTURAM, NRESTRUTURAH, NRORG, DTMESCOMPETENC, IDOPTSIMPLES, DTINCLUSAO,
                        CDCNPJESTRUT, NMRAZSOCESTRUT, NRPARCNEGOCIO)
                  VALUES(TO_NUMBER(V_PRXCODIGO_M), TO_NUMBER(V_PRXCODIGO_H), C_FILIAL.NRORG, V_DTREFERENCIA, DECODE(V_CDSITUCRT, '3', 'N', 'S'), SYSDATE,
                      C_FILIAL.NRINSJURFILI, C_FILIAL.NMFILIAL, TO_NUMBER(V_PRXCODIGO_PARCNEGOCIO));
                  COMMIT;
               END LOOP;
            END;";
        try{
            $db->execute($sql);
        }
        catch(\Exception $e){
            //suprime qualquer erro que possa acontecer;

        }
    }

}