/*
-- ========================================================================== --
-- MODPREPREC
-- ========================================================================== --
*/
CREATE OR REPLACE VIEW MODPREPREC(CDRECEITA,NRMPREPREC,DSMPREPREC,NMRESPREC,
                                  IDSITMODP)
AS
SELECT DP.CDPRODUTO,LPAD(TO_CHAR(ROWNUM),2,'0'),DP.DSDOCUPROD,
       OP.NMOPERADOR,DECODE(DP.CDTIPODOCU,PC.CDTIPODOCU,'1','2')
FROM DOCUPROD DP, PARAMCOMIS PC, ESPEPROD EP, PRODUTO P1, OPERADOR OP
WHERE (DP.IDLOCDOCPROD = 'T'          ) AND /*Texto*/
      (EP.IDTPMANUAL     IS NULL      ) AND
      (EP.IDCOMPPADRAO = 'P'          ) AND /*Padro*/
      (EP.CDPRODUTO    = DP.CDPRODUTO ) AND
      (EP.CDESPEPROD   = DP.CDESPEPROD) AND
      (EP.DTVALESPEPRO = (SELECT MAX(DTVALESPEPRO)
                          FROM ESPEPROD
                          WHERE (DTVALESPEPRO <= TRUNC(SYSDATE)) AND
                                (IDTPMANUAL      IS NULL       ) AND
                                (IDCOMPPADRAO  = 'P'           ) AND
                                (CDPRODUTO     = EP.CDPRODUTO  ) AND
                                (CDESPEPROD    = EP.CDESPEPROD ))) AND
      (P1.CDPRODUTO    = DP.CDPRODUTO ) AND
      (P1.IDPRODCOMISS = '3'          ) AND /*Receita*/
      (OP.CDOPERADOR   = EP.CDOPERADOR) AND
      (PC.CDFILIAL     = EP.CDFILIAL  )
/
